// Edited version of rph's plugin to make it use the base rpg maker icons, changed by vl
{

    let _old_window_battle_actor_status_createSprites = Window_OmoriBattleActorStatus.prototype.createACSBubbleSprites;
    let _old_window_battle_actor_status_updatePositions = Window_OmoriBattleActorStatus.prototype.updatePositions;
    Window_OmoriBattleActorStatus.prototype.createACSBubbleSprites = function() {
        this._stateIcons = new Sprite(new Bitmap(96, 16));
        this._stateIcons.x = 0;
        this._stateIcons.y = this.y < 240 ? this.y + this.height : this.y;
        this._stateIconCache = [];
        this.addChild(this._stateIcons);

        _old_window_battle_actor_status_createSprites.call(this, ...arguments);
    }

    Window_OmoriBattleActorStatus.prototype.updatePositions = function() {
        _old_window_battle_actor_status_updatePositions.call(this, ...arguments);

        this._stateIcons.x = (this.width - 96) / 2;
        this._stateIcons.y = this.y < 240 ? this.height : -16;

        // Determine if we need to update
        let nc = [];
        let actor = this.actor();
        if (actor) {
            for (let state of actor._states) {
                if ($dataStates[state] && $dataStates[state].iconIndex != 0) {
                    nc.push(state);
                }
            }
        }
        if (JSON.stringify(nc) !== JSON.stringify(this._stateIconCache)) {
            this._stateIcons.bitmap.fillAll('rgba(0, 0, 0, 0)')
            while(this._stateIcons.children[0]) {
                this._stateIcons.removeChild(this._stateIcons.children[0]);
            }
            let totalLength = nc.length;
            let elapsed = 0;
            for (let s of nc) {
                icon = $dataStates[s].iconIndex;
                let sprite = new Sprite(ImageManager.loadSystem("IconSet"));
                this._stateIcons.addChild(sprite);
                sprite._frame.x = icon % 16 * 32;
                sprite._frame.y = Math.floor(icon / 16) * 32;
                sprite.anchor.set(0, 0);
                sprite.width = 32
                sprite.height = 32
                sprite.y = 0;
                sprite.x = ((96 - (totalLength * 16)) / 2) + elapsed * 16;
                elapsed++;
            }

            this._stateIconCache = nc;
        }
        this._stateIcons.update();
        //if ($gameScreen._brightness === 255) debugger;
        
    }

    let _old_sprite_enemybattlerstatus_refreshBitmap = Sprite_EnemyBattlerStatus.prototype.refreshBitmap;
    Sprite_EnemyBattlerStatus.prototype.refreshBitmap = function(battler) {
        _old_sprite_enemybattlerstatus_refreshBitmap.call(this, ...arguments);
        if (!this._stateIcons) {
            this._stateIcons = new Sprite(new Bitmap(96, 16));
        }
        let nc = [];
        if (battler) {
            this._stateIcons.x = (this.bitmap.width - 96) / 2;
            this._stateIcons.y = -16;
            this._stateIcons.bitmap.fillAll('rgba(0, 0, 0, 0)');
            this.addChild(this._stateIcons);
            for (let state of battler._states) {
                if ($dataStates[state] && $dataStates[state].iconIndex != 0) {
                    nc.push(state);
                }
            }
        }
        while(this._stateIcons.children[0]) {
            this._stateIcons.removeChild(this._stateIcons.children[0]);
        }
        let totalLength = nc.length;
        let elapsed = 0;
        for (let s of nc) {
            icon = $dataStates[s].iconIndex;
            let sprite = new Sprite(ImageManager.loadSystem("IconSet"));
            this._stateIcons.addChild(sprite);
            sprite._frame.x = icon % 16 * 32;
            sprite._frame.y = Math.floor(icon / 16) * 32;
            sprite.anchor.set(0, 0);
            sprite.width = 32
            sprite.height = 32
            sprite.y = 0;
            sprite.x = ((96 - (totalLength * 16)) / 2) + elapsed * 16;
            elapsed++;
        }
        this._stateIcons.update();
    }
	
}